/*
 * Copyright (C) 2001 - 2003 Min Hsu
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _GDATAPOOL_H_
#define _GDATAPOOL_H_

#include <stdio.h>

typedef struct gDataPool
{
  void *pAny;
  unsigned int uiRfrncd;
  struct timeval tStamp;
  void (*pfAnyFree)(void *);
  struct gDataPool *pPrev;
  struct gDataPool *pNext;
} GDATAPOLL; 

/* Get the first in the pool */
#define GETFIRST(p, pf) \
  for(pf=p; pf->pPrev; pf=pf->pPrev)

/* Get the last */
#define GETLAST(p, pl) \
  for(pl=p; pl->pNext; pl=pl->pNext)

#ifdef __cplusplus
extern "C" {
#endif

GDATAPOLL *newElement(GDATAPOLL *);
void deleteElement(GDATAPOLL *);
void deleteAllElement(GDATAPOLL *);

#ifdef __cplusplus
};
#endif

#endif
