/*
 * Copyright (C) 2001 - 2003 Min Hsu
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _GENCERTS_H_
#define _GENCERTS_H_

#include <stdio.h>

#include <openssl/x509.h>
#include <openssl/evp.h>

#define DEFAULTKLEN 0x400

typedef struct rootCaCert 
{
  X509 *pRootCA;
  EVP_PKEY *pRootPrivKey;
} RTCACERT;

typedef struct signedCert 
{
  X509 *pSignedCert;
  EVP_PKEY *pPkey;
} SGNDCERT;

RTCACERT *loadCaCert(const char *, const char *);
void freeCaCert(RTCACERT *);
SGNDCERT *createX509Cert(RTCACERT *, const short, const short);
void freeSignedCert(SGNDCERT *);

#endif
