/*
 * Copyright (C) 2001 - 2003 Min Hsu
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _GMLMONIT_H_
#define _GMLMONIT_H_

#include <stdio.h>
#include <sys/time.h>

#include <gmlmutex.h>
#include <gmlthread.h>
#include <gdatapool.h>

typedef struct clientInfo
{
  unsigned long ulClntId;
  unsigned long ulRmtIP;
  unsigned char ucStatus;
#define SENSORUP  0x1
#define SNSRSUSP  0x2
#define SNSRSTOP  0x4
  int iSockFd;
  gmlThread tThrdId;
} CLIENTINF;

typedef struct serverCnfg
{
  char *pParmName;
  char *pParmCV;
  int pParmIV;
} SERVERCFG;

typedef struct monitServer
{
  GDATAPOLL *pClntInfo;
  GDATAPOLL *pClntData;
  GDATAPOLL *pSrvrCnfg;
  gmlThread tExtThrdId;
  gmlThread tDbiThrdId;
  gmlThread tMainThdId;
  gmlCond *pCnd;
  gmlMutex *pDtMtx;
  gmlMutex *pIfMtx;
  void *pCert;
  char cException;
  unsigned char ucActvClnts;
  unsigned int uiNoDbs;
} MONITSRVR;

#ifdef __cplusplus
extern "C" {
#endif

int initMonitServer(MONITSRVR *);
void dstryMonitServer(MONITSRVR *);
void *doClientThread(void *);
void *doExtractThread(void *);
void *doDbInsertThread(void *);
int uSockWait(const int, const int);
int uTimeWait(const int);
void freeCnfgElement(void *);
int getCnfgIntElement(const char *, GDATAPOLL *);
char *getCnfgCharElement(const char *, GDATAPOLL *);
int timeValComp(const struct timeval *, const struct timeval *);

int monitGUI(void *);
int loadConfig(void *, const char *);

#ifdef __cplusplus
}
#endif

#define DFTSNSRPORT  2001
#define DFTRSAKEYLN  1024
#define DFTDAYVALID  30

#endif
