/*
   Copyright (C) 2000 - 2003 Min Hsu

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifndef _GMLMUTEX_H_
#define _GMLMUTEX_H_

#include <pthread.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct { 
  pthread_mutex_t mutex;
} gmlMutex;

typedef struct { 
  pthread_cond_t cond;
} gmlCond;

int gmlMxLock(gmlMutex *);
int gmlMxUnLock(gmlMutex *);
int gmlMxTryLock(gmlMutex *);
gmlMutex *gmlMxInit(void);
void gmlMxDstry(gmlMutex *);

int gmlCdSignal(gmlCond *);
int gmlCdBroadcast(gmlCond *);
int gmlCdWait(gmlCond *, gmlMutex *);
int gmlCdTimedWait(gmlCond *, gmlMutex *, unsigned long millis);
gmlCond *gmlCdInit(void);
void gmlCdDstry(gmlCond *);

#ifdef __cplusplus
};
#endif

#endif
