/*
 * Copyright (C) 2001 - 2003 Min Hsu
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _SSLUTIL_H_
#define _SSLUTIL_H_

#include <stdio.h>
#include <openssl/ssl.h>

void sslInit(void);
void sslClean(void);
SSL_CTX *initServerCtx(X509 *, EVP_PKEY *);
SSL_CTX *initClientCtx(void *);
void cleanCtx(SSL_CTX *);
SSL *acceptClient(SSL_CTX *, const int);
SSL *connetServer(SSL_CTX *, const int);
void disconnectSSL(SSL *, const short);
int readSSL(SSL *, unsigned char *, int);
int writeSSL(SSL *, const unsigned char *, int);

#endif
