create table addrinfo (
  addrId int unsigned not null,
  srcIp int unsigned not null,
  dstIp int unsigned not null,
  PRIMARY KEY (srcIp, dstIp),
  INDEX idxSrcIp (srcIp),
  INDEX idxDstIp (dstIp),
  INDEX idxId (addrId)
) TYPE = InnoDB;

create table events (
  eventId int unsigned not null,
  sensorId int unsigned not null,
  signatureId int unsigned not null,
  eventTime int unsigned not null,
  eventMsg text not null,
  srcPort smallint unsigned not null,
  dstPort smallint unsigned not null,
  srcMac char(18),
  dstMac char(18),
  protocolID smallint unsigned,
  priority smallint unsigned,
  addrId int unsigned,
  PRIMARY KEY (eventId),
  FOREIGN KEY (addrId) REFERENCES addrinfo(addrId),
  INDEX idxSrcPt (srcPort),
  INDEX idxDstPt (dstPort),
  INDEX idxEvtTime (eventTime),
  INDEX idxSigId (signatureId)
);

create table reference (
  signatureId int unsigned not null,
  httpReference char(128) not null,
  PRIMARY KEY (signatureId, httpReference)
);
