/*
 * Copyright (C) 2001 - 2003 Min Hsu
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 *  $Id$
 */

#ifndef _DBPROCS_H_
#define _DBPROCS_H_

typedef struct AtckInfo
{
  unsigned int uiTtlRows;
  unsigned short usSigId;
  short sPrrty;
  unsigned int uiAtckt;
  unsigned int uiAtcks;
  unsigned int uiAtckrs;
  unsigned int uiAtckd;
  unsigned int uiMsgLen;
} ATCKINFO;

#define ATCKIFLEN     sizeof(ATCKINFO)

typedef struct DtlInfo
{
  unsigned int uiTtlRows;
  unsigned int uiSnsrId;
  unsigned long ulEvtTime;
  unsigned short usPrtclId;
  short sPrrty; 
  unsigned long ulSrcIp;
  unsigned short usSrcPt;
  unsigned long ulDstIp;
  unsigned short usDstPt;
  char cSrcMac[18];
  char cDstMac[18];
  unsigned int uiMsgLen;
} DTLINFO;

#define DTLIFLEN     sizeof(DTLINFO)

typedef int (*pFuncProc)(const unsigned char *,
                         const unsigned short, const void *);

void *doDbInsertThread(void *);

#ifdef __cplusplus
extern "C" {
#endif

int dbFetchAtckInfo(void *, const char*, pFuncProc, const void *);
int dbFetchDetails(void *, const char*, pFuncProc, const void *);
int dbFetchReference(void *, const char*, pFuncProc, const void *);

#ifdef __cplusplus
}
#endif

#endif
