/*
 * Copyright (C) 2000 - 2003 Min Hsu
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <string.h>
#include <signal.h>

#include "gmlthread.h"
#include "printmsg.h"

inline gmlThread gmlThreadCreate(void *(pfnc)(void *), void *arg)
{
  int iErr=0;
  pthread_t tId=-1;

  if((iErr=pthread_create(&tId, NULL, pfnc, arg)))
  {
    errorMessage("%s\n", (char *)strerror(iErr)); 
    return (pthread_t)(-1);
  }

  return tId;
}

inline int gmlThreadCancel(gmlThread tId)
{
  return pthread_cancel(tId);
}

inline int gmlThreadJoin(gmlThread tId)
{
  return pthread_join(tId, NULL);
}

inline int gmlThreadDetach(gmlThread tId)
{
  return pthread_detach(tId);
}

inline int gmlThreadCancelable()
{
  return pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, NULL);
}

inline int gmlThreadCancelDisable()
{
  return pthread_setcancelstate(PTHREAD_CANCEL_DISABLE, NULL);
}

inline void gmlThreadExit()
{
  pthread_exit(0);
}

inline int gmlThreadSuspend(gmlThread tId)
{
  return pthread_kill(tId, SIGSTOP);
}

inline int gmlThreadContinue(gmlThread tId)
{
  return pthread_kill(tId, SIGCONT);
}

inline int gmlThreadTerminate(gmlThread tId)
{
  return pthread_kill(tId, SIGTERM);
}

inline gmlThread gmlThreadId()
{
  return pthread_self();
}
