/*
 * Copyright (C) 2001 - 2003 Min Hsu
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _GMLTHREAD_H_
#define _GMLTHREAD_H_

#include <pthread.h>

typedef pthread_t gmlThread;

#ifdef __cplusplus
extern "C" {
#endif 

gmlThread gmlThreadCreate(void *(pfnc)(void *), void *);
int gmlThreadJoin(gmlThread);
int gmlThreadDetach(gmlThread);
int gmlThreadContinue(gmlThread);
int gmlThreadSuspend(gmlThread);
int gmlThreadCancel(gmlThread);
int gmlThreadCancelable();
int gmlThreadCancelDisable();
int gmlThreadTerminate(gmlThread);
gmlThread gmlThreadId();
void gmlThreadExit();

#ifdef __cplusplus
};
#endif

#endif
