/*
 * Copyright (C) 2001 - 2003 Min Hsu
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _MONITGUI_H_
#define _MONITGUI_H_

#include <qmainwindow.h>
#include <qfont.h>

#include <report.h>
#include <eventview.h>
#include <statsview.h>

class MonitGUI: public QMainWindow
{
  Q_OBJECT

public:
  MonitGUI(void *pUser, QWidget *parent=0,
           const char *name=0, WFlags f=WType_TopLevel);
  ~MonitGUI()
  {
    delete pEventView;
    delete pStatsView;
  }

protected slots:
  void about();
  void readMsg(void);

private:
  void *pMonit;
  struct timeval tTmStmp;
  EventView *pEventView;
  StatsView *pStatsView;
  void selectStyleMenu(int);
};

#endif
