/*
 * Copyright (C) 2001, 2002 Min Hsu
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _GLIST_H_
#define _GLIST_H_

#include <stdio.h>

typedef struct genericList
{
  void *pAny;
  void (*pfAnyFree)(void *);
  struct genericList *pPrev;
  struct genericList *pNext;
} GnrcList;

typedef int (*pCmpFnc)(void *, void *);

/* Get the first in the pool */
#define GETFIRST(p, pf) \
  for(pf=p; pf->pPrev; pf=pf->pPrev)

/* Get the last */
#define GETLAST(p, pl) \
  for(pl=p; pl->pNext; pl=pl->pNext)

#ifndef errorMessage
#define errorMessage(arg...)                        \
  fprintf(stderr, "%s:%d ", __FILE__, __LINE__),    \
  fprintf(stderr, ##arg)
#endif

#ifdef __cplusplus
extern "C" {
#endif

GnrcList *initGList(void);
GnrcList *addElm(GnrcList *);
GnrcList *getElm(GnrcList *, void *, pCmpFnc);
void delElm(GnrcList *);
void delAllElm(GnrcList *);

#ifdef __cplusplus
}
#endif

#endif
