/*
 * Copyright (C) 2001 - 2003 Min Hsu
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _SNORTDATA_H_
#define _SNORTDATA_H_

#include <stdio.h>
#include <sys/time.h>

typedef struct sensorEvent
{
  unsigned long ulMsgId;
  unsigned long ulSensorId;
  unsigned long ulSgntrId;
  struct timeval eventTime;
  unsigned char ucSrcMac[6];
  unsigned char ucDstMac[6];
  unsigned short usPrtclID;
  unsigned short padToLong;
  unsigned long ulSrcIp;
  unsigned long ulDstIp;
  unsigned short usSrcPort;
  unsigned short usDstPort;
  unsigned short usPriority;
  unsigned short usEvtLen;
  char *pEventMsg;
} SNSREVENT;

typedef struct sensorStatistic
{
  unsigned long ulMsgId;
  unsigned long ulSensorId;
  struct timeval sensorTime;
  unsigned long ulAltPkts;
  unsigned long ulLogPkts;
  unsigned long ulPsdPkts;
  unsigned long ulTcpPkts;
  unsigned long ulUdpPkts;
  unsigned long ulIcmpPkts;
  unsigned long ulArpPkts;
  unsigned long ulIpxPkts;
  unsigned long ulOthPkts;
  unsigned long ulDscdPkts;
  unsigned long ulFrgIPPkts;
  unsigned long ulRbtIpPkts;
  unsigned long ulStrmTcpPkts;
  unsigned long ulRcnsTcpPkts;
  unsigned long ulRcnsStrmPkts;
} SNSRSTATS;

#define EVENTMSG  0x1a2b3c40
#define STATIMSG  0x1a2b3c41
#define PSEUDOHDLEN  (sizeof(SNSREVENT) - 4)
#define STATSTUBLEN  (sizeof(SNSRSTATS) - PSEUDOHDLEN)

#endif
