/*
 *  Copyringth (C) 2001 - 2003 Min Hsu
 *  All Rights Reserved
 *
 *  $Id$
 */

#ifndef _SQLODBC_H_
#define _SQLODBC_H_

#include <stdio.h>
#include <stdlib.h>

#include <sql.h>
#include <sqlext.h>
#include <sqltypes.h>

#define C_CHAR     SQL_CHAR
#define C_VCHAR    SQL_VARCHAR
#define C_DTIME    SQL_DATETIME
#define C_LONG     SQL_INTEGER
#define C_SHORT    SQL_SMALLINT
#define C_FLOAT    SQL_REAL
#define C_DOUBLE   SQL_DOUBLE

typedef struct
{
  long sqlcd;
  char *pErrMsg;
} SQLMSG;

typedef struct
{
  void *pData;
  SQLINTEGER tIndicator;
  SQLSMALLINT tColType;
} ODBCBind;

#ifdef __cplusplus
extern "C" {
#endif

int dbInitEnv(void **, SQLMSG *);
int dbExitEnv(void *, SQLMSG *);
int dbConnect(char *, char *, char *, void *,
              void **, unsigned long, SQLMSG *);
int dbDisconn(void *, void *, SQLMSG *);
int sqlPrep(void *, void *, char *, void * *, short *, SQLMSG *);
int sqlBind(void *, void *, void *, short, char *, short, SQLMSG *);
int sqlExec(void *, void *, void *, int *, short *, SQLMSG *);
int dirExec(void *, void *, char *, SQLMSG *);
int sqlDesc(void *, void *, void *, short, ODBCBind **, SQLMSG *);
int sqlGetOne(void *, void *, void *, const short, void *,
              const unsigned short, const short, SQLMSG *);
int sqlFetch(void *, void *, void *, SQLMSG *);
int sqlFree(void *, void *, void *, short, ODBCBind *, SQLMSG *);
void dbErrMsg(void *, void *, void *, SQLMSG *);

#ifdef __cplusplus
}
#endif

#endif
