/*
 * Copyright (C) 2001 - 2003 Min Hsu
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>
#include <string.h>

#include <gmlmonit.h>
#include <gdatapool.h>

inline void freeCnfgElement(void *pCnfg)
{
  if(pCnfg)
  {
    if(((SERVERCFG *)pCnfg)->pParmName)
      free(((SERVERCFG *)pCnfg)->pParmName);
    if(((SERVERCFG *)pCnfg)->pParmCV)
      free(((SERVERCFG *)pCnfg)->pParmCV);
  }
}

inline char *getCnfgCharElement(const char *pName, GDATAPOLL *pElm)
{
  GDATAPOLL *pFirst = NULL;

  if(pName && pElm)
  {
    GETFIRST(pElm, pFirst);
#define CNFGINFO pFirst->pNext->pAny
    while(pFirst->pNext && CNFGINFO)
    {
      if(!strncmp(((SERVERCFG *)CNFGINFO)->pParmName, pName, strlen(pName)))
        return ((SERVERCFG *)CNFGINFO)->pParmCV;
#undef CNFGINFO

      pFirst = pFirst->pNext;
    }
  }

  return NULL;
}

inline int getCnfgIntElement(const char *pName, GDATAPOLL *pElm)
{
  GDATAPOLL *pFirst = NULL;

  if(pName && pElm)
  {
    GETFIRST(pElm, pFirst);
#define CNFGINFO pFirst->pNext->pAny
    while(pFirst->pNext && CNFGINFO)
    {
      if(!strncmp(((SERVERCFG *)CNFGINFO)->pParmName, pName, strlen(pName)))
        return ((SERVERCFG *)CNFGINFO)->pParmIV;
#undef CNFGINFO

      pFirst = pFirst->pNext;
    }
  }

  return -1;
}
