/*
 * Copyright (C) 2001 - 2003 Min Hsu
 * All Rights Reserved
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <qxml.h>
#include <qstring.h>

class ConfigParser : public QXmlDefaultHandler
{
public:
  ConfigParser(void *pUser)
  {
    pMonit = pUser;
  }

  ~ConfigParser() {}

  bool startDocument()
  {
    return true;
  }
  
  bool startElement(const QString &, const QString &rTname,
                      const QString &, const QXmlAttributes &rType)
  {
    strTag = rTname;
    strType = rType.value("type");
    return true;
  }

  bool endElement(const QString &, const QString &, const QString &)
  {
    return true;
  }
   
  bool characters(const QString &);

private:
  void *pMonit;
  QString strTag;
  QString strType;
};                   
